def call(cmdline, _in):
    import os, commands, tempfile

    """A convenience function to invoke a subprocess with the
    parameter list name (where the first argument is the name
    of an executable). The subprocess is fed the contents of
    input via stdin. We collect the output of both stdout and
    stderr from the subprocess. If stderr is not empty, we
    raise an exception, otherwise we return the contents of
    stdout."""

    # create temporary files
    fidin, tmpfilein = tempfile.mkstemp()
    os.close(fidin)
    fidout, tmpfileout = tempfile.mkstemp()
    os.close(fidout)

    # write text to be translated
    fidin = open(tmpfilein, "w")
    fidin.write(_in.encode('utf-8'))
    fidin.close()

    # call apertium
    cmdline.append(tmpfilein)
    cmdline.append(tmpfileout)
    err, out = commands.getstatusoutput(" ".join(cmdline))
    os.remove(tmpfilein)

    # get translated text
    fidout = open(tmpfileout, "r")
    out = fidout.read()
    fidout.close()
    os.remove(tmpfileout)

    return out, err

class OsCommand(object):
    def __init__(self, cmd):
        self.cmd = cmd

    def communicate(self, _input):
        print "calling", self.cmd
        return call(self.cmd, _input)

